/*************************************************************************
**************************************************************************
**                                                                      **
**  Project:   PS/2 Keyboard => NKC                                     **
**  Title:     PS/2 Interface => NKC Implementation                     **
**  File:      USART.h                                                  **
**  Date:      29.11.2008                                               **
**  Version:   0.82                                                     **
**  Plattform: WinAVR-20060421 & AVR Studio 4.12.498 & STK500           **
**                                                                      **
**  Created by Gerald Ebert                                             **
**                                                                      **
**************************************************************************/

#ifndef _USART_H_
  #define _USART_H_

//========================================================================
// CPU model independant defines
//========================================================================

#define USART_BAUD9K6   ((F_CPU/16/  9600) - 1)
#define USART_BAUD19K   ((F_CPU/16/ 19200) - 1)
#define USART_BAUD28K   ((F_CPU/16/ 28800) - 1)
#define USART_BAUD38K   ((F_CPU/16/ 38400) - 1)
#define USART_BAUD56K   ((F_CPU/16/ 57600) - 1)
#define USART_BAUD115K  ((F_CPU/16/115200) - 1)
#define USART_BAUD230K  ((F_CPU/16/230400) - 1)

#define USART_PARITY_NONE    0
#define USART_PARITY_EVEN    2
#define USART_PARITY_ODD     3
#define USART_1STOP_BIT      0
#define USART_2STOP_BITS     _BV(USBS0)

//========================================================================
// Exported Functions
//========================================================================

extern  void USART_Init(WORD BaudrateValue, BYTE ParityMode, BYTE StopBits);
extern  void USART_Transmit(BYTE Data);
extern  void USART_TransmitString(LPCSTR str);
extern  void USART_TransmitPString(LPCPSTR str);
extern  void USART_TransmitBuffer(LPCBYTE buffer, INT buflen);

#if defined(USART_RECEIVE)
  extern  BYTE USART_Receive(void);
#endif

//========================================================================

#endif // _USART_H_
